#!/bin/sh

PATH=/sbin:/usr/sbin:/bin:/usr/bin

WIFNAME=$1
TYPE=$2

SXSYSCONF="/usr/sbin/sxsysconf"
WPACLI="/usr/bin/wpa_cli"
WPS_STATUS_PATH="/var/cache/wps.stat"

wps_action() {
	NETID=`${WPACLI} -i ${WIFNAME} list_network | grep CURRENT | cut -f1`
	case "${1}" in
	'pbc')
		echo " WPS_ACTION PBC" > /dev/console
		${SXSYSCONF} -f ${WPS_STATUS_PATH} -w INPROG LASTSTAT
		${SXSYSCONF} -f ${WPS_STATUS_PATH} -w "${1}" METHOD
		${SXSYSCONF} -f ${WPS_STATUS_PATH} -w "0"    WAIT_CONNECT
		${SXSYSCONF} -f ${WPS_STATUS_PATH} -w "${NETID}" BEFORE_NETID
		${WPACLI} -i ${WIFNAME} wps_pbc > /dev/null
		;;
	'pin')
		echo " WPS_ACTION PIN" > /dev/console
		${SXSYSCONF} -f ${WPS_STATUS_PATH} -w INPROG LASTSTAT
		${SXSYSCONF} -f ${WPS_STATUS_PATH} -w "${1}" METHOD
		${SXSYSCONF} -f ${WPS_STATUS_PATH} -w "${2}" ENROLLEEPIN
		${SXSYSCONF} -f ${WPS_STATUS_PATH} -w "0"    WAIT_CONNECT
		${SXSYSCONF} -f ${WPS_STATUS_PATH} -w "${NETID}" BEFORE_NETID
		${WPACLI} -i ${WIFNAME} wps_pin any ${2} > /dev/null
		;;
	*)
		echo " ${1}" > /dev/console
		;;
	esac
}

case "${TYPE}" in
'wps')
	wps_action ${3} ${4}
	;;
*)
	echo "${TYPE}" > /dev/console
	;;
esac

